<form [formGroup]="form">
  <table>
    <tr>
      <th>Name</th>
      <td>
        <input type="text" [formControlName]="'name'" />
      </td>
      <td>
        <ul *ngIf="f.name.dirty && f.name.invalid">
          <li *ngIf="f.name.errors.required">Must have a value</li>
          <li *ngIf="f.name.errors.pattern">Only letters and blank</li>
          <li *ngIf="f.name.errors.minlength">
            At least {{f.name.errors.minlength.requiredLength}} chars
          </li>
        </ul>
      </td>
    </tr>
    <tr>
      <th>Age</th>
      <td>
        <input type="number" [formControlName]="'age'" />
      </td>
      <td>
        <ul *ngIf="f.age.dirty && f.age.invalid">
          <li *ngIf="f.age.errors.required">Must have a value</li>
          <li *ngIf="f.age.errors.min">At least age {{f.age.errors.min.min}}</li>
          <li *ngIf="f.age.errors.max">At most age {{f.age.errors.max.max}}</li>
        </ul>
      </td>
    </tr>
    <tr>
      <th></th>
      <td colspan="2" class="buttons">
        <button type="submit" (click)="onSubmit()" [disabled]="form.invalid" class="submit">Submit</button>
        <button type="reset" (click)="onCancel()" class="cancel">Cancel</button>
      </td>
    </tr>
  </table>
</form>

<hr />
<div class="debug">
  <pre>
payload: {{form.value | json}}
name.errors: {{f.name.errors | json}}
age.errors : {{f.age.errors | json}}
    </pre>
</div>
